/*
 * (C) Copyright IBM Corp. 2004
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  This
 * file and program are licensed under a BSD style license.  See
 * the Copying file included with the OpenHPI distribution for
 * full licensing terms.
 *
 * Authors:
 *   Konrad Rzeszutek <konradr@us.ibm.com>

 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.array-user.conf,v 5.18 2003/11/07 17:03:52 rstory Exp $
 *
 * $Id: saHpiSensorThdLowMinorTable.h,v 1.3 2004/03/23 04:20:20 konradrzeszutek Exp $
 *
 */
#ifndef SAHPISENSORTHDLOWMINORTABLE_H
#define SAHPISENSORTHDLOWMINORTABLE_H

#ifdef __cplusplus
extern "C"
{
#endif


#include <net-snmp/net-snmp-config.h>
#include <net-snmp/library/container.h>
#include <net-snmp/agent/table_array.h>
#include <SaHpi.h>
#include <hpiSubagent.h>


	/** Index saHpiDomainID is external */
	/** Index saHpiResourceID is external */
	/** Index saHpiSensorIndex is external */

  typedef struct saHpiSensorThdLowMinorTable_context_s
  {
    netsnmp_index index;

    /** TruthValue = ASN_INTEGER */
    long            saHpiSensorThdLowMinorIsReadable;
    
    /** TruthValue = ASN_INTEGER */
    long            saHpiSensorThdLowMinorIsWritable;
    
    /** TruthValue = ASN_INTEGER */
    long            saHpiSensorThdLowMinorIsFixed;
    
    /** INTEGER = ASN_INTEGER */
    long            saHpiSensorThdLowMinorValuesPresent;

    /** UNSIGNED32 = ASN_UNSIGNED */
    unsigned long   saHpiSensorThdLowMinorRaw;

	/** OCTETSTR = ASN_OCTET_STR */
    unsigned char
      saHpiSensorThdLowMinorInterpreted[SENSOR_THD_INTER_MAX];
    size_t saHpiSensorThdLowMinorInterpreted_len;



    SaHpiResourceIdT resource_id;
    SaHpiDomainIdT domain_id;
    SaHpiSensorNumT sensor_id;
    long hash;


  } saHpiSensorThdLowMinorTable_context;

/*************************************************************
 * function declarations
 */

  void initialize_table_saHpiSensorThdLowMinorTable (void);

  int
    delete_ThdLowMinor_row (SaHpiDomainIdT domain_id,
			       SaHpiResourceIdT resource_id,
			       SaHpiSensorNumT num);

  int populate_ThdLowMinor (SaHpiDomainIdT domain_id,
			       SaHpiResourceIdT resource_id,
			       SaHpiSensorNumT sensor_id,
			       SaHpiSensorThdDefnT *threshold_def,
			       SaHpiSensorReadingT * reading);


  int set_ThdLowMinor (saHpiSensorThdLowMinorTable_context *ctx);

  int
    saHpiSensorThdLowMinorTable_get_value (netsnmp_request_info *,
					      netsnmp_index *,
					      netsnmp_table_request_info *);


/*************************************************************
 * oid declarations
 */
  extern oid saHpiSensorThdLowMinorTable_oid[];
  extern size_t saHpiSensorThdLowMinorTable_oid_len;

#define saHpiSensorThdLowMinorTable_TABLE_OID hpiSensor_OID,9

/*************************************************************
 * column number definitions for table saHpiSensorThdLowMinorTable
 */
#define COLUMN_SAHPISENSORTHDLOWMINORISREADABLE 1
#define COLUMN_SAHPISENSORTHDLOWMINORISWRITABLE 2
#define COLUMN_SAHPISENSORTHDLOWMINORISFIXED 3
#define COLUMN_SAHPISENSORTHDLOWMINORVALUESPRESENT 4
#define COLUMN_SAHPISENSORTHDLOWMINORRAW 5
#define COLUMN_SAHPISENSORTHDLOWMINORINTERPRETED 6
#define saHpiSensorThdLowMinorTable_COL_MIN 1
#define saHpiSensorThdLowMinorTable_COL_MAX 6

  int
    saHpiSensorThdLowMinorTable_extract_index
    (saHpiSensorThdLowMinorTable_context * ctx, netsnmp_index * hdr);

  void saHpiSensorThdLowMinorTable_set_reserve1 (netsnmp_request_group *);
  void saHpiSensorThdLowMinorTable_set_reserve2 (netsnmp_request_group *);
  void saHpiSensorThdLowMinorTable_set_action (netsnmp_request_group *);
  void saHpiSensorThdLowMinorTable_set_commit (netsnmp_request_group *);
  void saHpiSensorThdLowMinorTable_set_free (netsnmp_request_group *);
  void saHpiSensorThdLowMinorTable_set_undo (netsnmp_request_group *);

    saHpiSensorThdLowMinorTable_context
    * saHpiSensorThdLowMinorTable_duplicate_row
    (saHpiSensorThdLowMinorTable_context *);
    netsnmp_index
    * saHpiSensorThdLowMinorTable_delete_row
    (saHpiSensorThdLowMinorTable_context *);

  int
    saHpiSensorThdLowMinorTable_can_delete
    (saHpiSensorThdLowMinorTable_context * undo_ctx,
     saHpiSensorThdLowMinorTable_context * row_ctx,
     netsnmp_request_group * rg);



    saHpiSensorThdLowMinorTable_context
    * saHpiSensorThdLowMinorTable_create_row (netsnmp_index *);

#ifdef __cplusplus
};
#endif

#endif /** SAHPISENSORTHDLOWMINORTABLE_H */
